package main

import (
	"context"
	"dy-test/dyrpc/helper"
	"dy-test/dyrpc/services/prod"
	"github.com/grpc-ecosystem/grpc-gateway/v2/runtime"
	"google.golang.org/grpc"
	"log"
	"net/http"
)

const (
	certFile = "/Users/duyong/workspace/gotest/dyrpc/ssl/client/client.pem"
	keyFile  = "/Users/duyong/workspace/gotest/dyrpc/ssl/client/client.key"
	caFile   = "/Users/duyong/workspace/gotest/dyrpc/ssl/ca/ca.pem"
)

func main() {
	gwmux := runtime.NewServeMux()
	opt := []grpc.DialOption{grpc.WithTransportCredentials(helper.GetCredentials(certFile, keyFile, caFile))}
	err := prod.RegisterProdServiceHandlerFromEndpoint(context.Background(), gwmux, "localhost:8081", opt)
	if err != nil {
		log.Fatal(err)
	}

	httpServer := &http.Server{
		Addr:    ":8080",
		Handler: gwmux,
	}
	err = httpServer.ListenAndServe()
	if err != nil {
		log.Fatal(err)
	}
}
