package services

import (
	"context"
	"dy-test/dyrpc/services/prod"
)

type ProdService struct {
	prod.UnimplementedProdServiceServer
}

func (p *ProdService) GetProdStock(ctx context.Context, request *prod.ProdRequest) (*prod.ProdResponse, error) {
	var stock int32
	switch request.ProdArea {
	case prod.ProdArea_A:
		stock = 0
	case prod.ProdArea_B:
		stock = 10
	case prod.ProdArea_C:
		stock = 20
	}
	return &prod.ProdResponse{ProdStock: stock}, nil
}

func (p *ProdService) GetProdStocks(context.Context, *prod.QueryProdStocks) (*prod.ProdStockList, error) {
	prdRes := []*prod.ProdResponse{

		&prod.ProdResponse{ProdStock: 10},
		&prod.ProdResponse{ProdStock: 20},
		&prod.ProdResponse{ProdStock: 30},
	}
	return &prod.ProdStockList{ProdRes: prdRes}, nil
}

func (p *ProdService) GetProdInfo(ctx context.Context, request *prod.ProdRequest) (*prod.ProdModel, error) {
	return &prod.ProdModel{
		ProdId:    request.ProdId,
		ProdName:  "aaa",
		ProdPrice: 20.5,
	}, nil
}

func (p *ProdService) mustEmbedUnimplementedProdServiceServer() {

}
